/*
dynamic.c
Writtrn by, sonimalik@users.sf.net
*/

#include <stdio.h>

#include "alf.h"
#include "stuff.h"
#include "dynamic.h"

GLOBAL __U16 dynamic(void){

   __U32 count           = ZERO;
   __U32 localCount      = ZERO;
   __U32 otherLocalCount = ZERO;
     
   for(;count< ((ELF32_HDR *)elfHeader)->e_phnum;){

      if( ((ELF32_PHDR *)programmHeader + count)->p_type == PT_DYNAMIC )
         break; 

       count++;
   }

   
   if( count == ((ELF32_HDR *)elfHeader)->e_phnum ){   
      printf("NO_DYNAMIC_SECTION\n");   
      if( argumentFlags[ALL] > ZERO )
         printf("\n");
      argumentValues[argumentFlags[DYNAMIC]] = NOT_FOUND;
      return(NO_ERROR);  
   }

  

   printf("\n** *Section(.dynamic)* **\n");
   printf("-----------------------------------------------------\n"); 

   if( readElfEntity( argumentValues[argumentFlags[FILE_NAME]], 
                     ((ELF32_PHDR *)programmHeader + count)->p_offset,
                     ((ELF32_PHDR *)programmHeader + count)->p_filesz,
                     &dynamicSection)  == ERROR )
      return(ERROR);

   count = ZERO;
   while( ((ELF32_DYN *)dynamicSection + count)->d_tag != DT_NULL  ) 
       count++;
     
   
   printf("The `.dynamic' section has %d entries, ", count + ONE);  
   printf("inclusive of DT_NULL.\n"); 
   count = ZERO;
   while( ((ELF32_DYN *)dynamicSection + count)->d_tag != DT_NULL ){

      switch( ((ELF32_DYN *)dynamicSection + count)->d_tag ){

         case DT_NEEDED:            
/* ------------------------------------------------------------------------ */

            localCount = ZERO;
            printf("\nELFX_DYN::d_tag = DT_NEEDED\n");
          printf("The name of the library required....\n");
            printf("The name is stored in section(DT_STRTAB) \"");

            while( ((ELF32_DYN *)dynamicSection + localCount)->d_tag 
                                                             != DT_NULL ){
               if( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                        == DT_STRTAB )
                  break;  
               
               localCount++;   
                
            }

            for(otherLocalCount = ZERO; 
                otherLocalCount < ((ELF32_HDR *)elfHeader)->e_shnum;
                otherLocalCount++){
                if( 
                    ((ELF32_DYN *)dynamicSection + localCount)->d_un.d_ptr
                    == ((ELF32_SHDR *)sectionHeader + otherLocalCount)->sh_addr 
                  )
                  break;     
            }
          
            readString(sectionHeaderStringBuffer, 
                       ((ELF32_SHDR *)sectionHeader + 
                       ((ELF32_HDR *)elfHeader)->e_shstrindx
                       )->sh_size,
                       ((ELF32_SHDR *)sectionHeader + otherLocalCount)->sh_name
                       );

            printf("\" .\n");
            
            printf("The name of the required library is \""); 
                       
             
            if( readElfEntity( argumentValues[argumentFlags[FILE_NAME]],
                           ((ELF32_SHDR *)sectionHeader + otherLocalCount
                           )->sh_offset,
                           ((ELF32_SHDR *)sectionHeader + otherLocalCount
                           )->sh_size,
                           &dtStringTableOfDynamicSection) == ERROR )
               return ERROR;



             readString( dtStringTableOfDynamicSection,
                       ((ELF32_SHDR *)sectionHeader + otherLocalCount)->sh_size,
                        ((ELF32_DYN *)dynamicSection + count)->d_un.d_val);
           
             printf("\" .\n");    
                                                            
               
 
            allocateOrFreeMemory( &dtStringTableOfDynamicSection, ZERO );
  

/* ----------------------------------------------------------------------- */
             
         break;

         case DT_PLTGOT:
            localCount = ZERO;
            printf("\nELFX_DYN::d_tag = DT_PLTGOT\n");
            printf("Address of the first byte of either PLT or GOT....\n"); 
            for(; localCount < ((ELF32_HDR *)elfHeader)->e_shnum;){
               if( ((ELF32_SHDR *)sectionHeader + localCount)->sh_addr 
                  == ((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr ){
                  printf("this time its the address of section `");
                  readString(sectionHeaderStringBuffer, 
                             ((ELF32_SHDR *)sectionHeader + 
                             ((ELF32_HDR *)elfHeader)->e_shstrindx)->sh_size,
                             ((ELF32_SHDR *)sectionHeader 
                             + localCount)->sh_name ); 
                  printf("'.\n");
                  printf("The first byte of this section starts at address 0x%.8x\n",((ELF32_DYN *)dynamicSection)->d_un.d_ptr);  
                   
               }
               localCount++; 
            } 
                                        
         break;
         case DT_HASH:
            localCount = 0;
            printf("\nELFX_DYN::d_tag = DT_HASH\n");
            for(; localCount < ((ELF32_HDR *)elfHeader)->e_shnum;){
               if( ((ELF32_SHDR *)sectionHeader + localCount)->sh_addr 
                  == ((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr ){
                  printf("The address of section `");
                  readString(sectionHeaderStringBuffer, 
                             ((ELF32_SHDR *)sectionHeader + 
                             ((ELF32_HDR *)elfHeader)->e_shstrindx)->sh_size,
                             ((ELF32_SHDR *)sectionHeader 
                             + localCount)->sh_name ); 
                  printf("'.\n");
                  printf("The first byte of this section starts at address 0x%.8x\n",((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr);
               }
               localCount++; 
            } 
         break;
         case DT_STRTAB:

            localCount = 0;
            printf("\nELFX_DYN::d_tag = DT_STRTAB\n");
            for(;localCount < ((ELF32_HDR *)elfHeader)->e_shnum;){
               if( ((ELF32_SHDR *)sectionHeader + localCount)->sh_addr 
                  == ((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr ){
                  printf("The address of section `");
                  readString(sectionHeaderStringBuffer, 
                             ((ELF32_SHDR *)sectionHeader + 
                             ((ELF32_HDR *)elfHeader)->e_shstrindx)->sh_size,
                             ((ELF32_SHDR *)sectionHeader 
                             + localCount)->sh_name ); 
                  printf("'.\n");
                  printf("The first byte of this section starts at address 0x%.8x\n",((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr);
               }
               localCount++; 
            }

            localCount = ZERO;
            printf("Size(DT_STRSZ) = ");
            while( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                         != DT_NULL      ){
               if( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                            == DT_STRSZ )
                  break;
               localCount++;
   
            }
            printf("%d(bytes) .\n", 
                   ((ELF32_DYN *)dynamicSection + localCount)->d_un.d_val );

         break;
         case DT_SYMTAB:
            localCount = 0;
            printf("\nELFX_DYN::d_tag = DT_SYMTAB\n");
            for(; localCount < ((ELF32_HDR *)elfHeader)->e_shnum;){
               if( ((ELF32_SHDR *)sectionHeader + localCount)->sh_addr 
                  == ((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr ){
                  printf("The address of section `");
                  readString(sectionHeaderStringBuffer, 
                             ((ELF32_SHDR *)sectionHeader + 
                             ((ELF32_HDR *)elfHeader)->e_shstrindx)->sh_size,
                             ((ELF32_SHDR *)sectionHeader 
                             + localCount)->sh_name ); 
                  printf("'.\n");
                  printf("The first byte of this section starts at address 0x%.8x\n",((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr);
               }
               localCount++; 
            }

            localCount = ZERO;
            printf("Size(DT_SYMENT) = ");
            while( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                         != DT_NULL      ){
               if( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                            == DT_SYMENT )
                  break;
               localCount++;
   
            }
            printf("%d(bytes) .\n", 
                   ((ELF32_DYN *)dynamicSection + localCount)->d_un.d_val );
 
         break;
         case DT_RELA:
/*----------------------------------------------- */

            localCount = 0;
            printf("\nELFX_DYN::d_tag = DT_RELA\n");
            for(; localCount < ((ELF32_HDR *)elfHeader)->e_shnum;){
               if( ((ELF32_SHDR *)sectionHeader + localCount)->sh_addr 
                  == ((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr ){
                  printf("The address of section `");
                  readString(sectionHeaderStringBuffer, 
                             ((ELF32_SHDR *)sectionHeader + 
                             ((ELF32_HDR *)elfHeader)->e_shstrindx)->sh_size,
                             ((ELF32_SHDR *)sectionHeader 
                             + localCount)->sh_name ); 
                  printf("'.\n");
                  printf("The first byte of this section starts at address 0x%.8x\n",((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr);
               }
               localCount++; 
            }
            localCount = ZERO;
            printf("Size(DT_RELASZ) = ");
            while( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                         != DT_NULL      ){
               if( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                            == DT_RELASZ )
                  break;
               localCount++;
   
            }
            printf("%d(bytes) .\n", 
                   ((ELF32_DYN *)dynamicSection + localCount)->d_un.d_val );
            localCount = ZERO;
            printf("Size(DT_RELAENT) = ");
            while( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                         != DT_NULL      ){
               if( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                            == DT_RELAENT )
                  break;
               localCount++;
   
            }
            printf("%d(bytes) .\n", 
                   ((ELF32_DYN *)dynamicSection + localCount)->d_un.d_val );



/*---------------------------------------------- */




         break;
         case DT_RELASZ:
         break;
         case DT_RELAENT:
         break;
         case DT_STRSZ:
         break;
         case DT_SYMENT:
         break;
         case DT_INIT:
            printf("\nELFX_DYN::d_tag = DT_INIT\n");
            printf("The pointer to initialization function....\n");
            printf("address of initialization function = 0x%.8x\n", 
                    ((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr);

            for(localCount = ZERO; 
                localCount < ((ELF32_HDR *)elfHeader)->e_shnum; localCount++){
               if( ((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr ==
                   ((ELF32_SHDR *)sectionHeader + localCount)->sh_addr )
                 break;                                 
            }
            
            printf("The section which has this function = \"");
            readString(sectionHeaderStringBuffer, 
                       ((ELF32_SHDR *)sectionHeader +
                         ((ELF32_HDR *)elfHeader)->e_shstrindx)->sh_size,
                       ((ELF32_SHDR *)sectionHeader + localCount)->sh_name); 
            printf("\" .\n");                           
         break;
         case DT_FINI:            
            printf("\nELFX_DYN::d_tag = DT_FINI\n");
            printf("The pointer to termination function....\n");
            printf("address of termination function = 0x%.8x\n", 
                    ((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr);

            for(localCount = ZERO; 
                localCount < ((ELF32_HDR *)elfHeader)->e_shnum; localCount++){
               if( ((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr ==
                   ((ELF32_SHDR *)sectionHeader + localCount)->sh_addr )
                 break;                                 
            }
            
            printf("The section which has this function = \"");
            readString(sectionHeaderStringBuffer, 
                       ((ELF32_SHDR *)sectionHeader +
                         ((ELF32_HDR *)elfHeader)->e_shstrindx)->sh_size,
                       ((ELF32_SHDR *)sectionHeader + localCount)->sh_name); 
            printf("\" .\n"); 
         break;
         case DT_SONAME:
/* ------------------------------------------------------------------------ */

            localCount = ZERO;
            printf("\nELFX_DYN::d_tag = DT_SONAME\n");
          printf("The realname of this shared object file....\n");
            printf("The name is stored in section(DT_STRTAB) \"");

            while( ((ELF32_DYN *)dynamicSection + localCount)->d_tag 
                                                             != DT_NULL ){
               if( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                        == DT_STRTAB )
                  break;  
               
               localCount++;   
                
            }

            for(otherLocalCount = ZERO; 
                otherLocalCount < ((ELF32_HDR *)elfHeader)->e_shnum;
                otherLocalCount++){
                if( 
                    ((ELF32_DYN *)dynamicSection + localCount)->d_un.d_ptr
                    == ((ELF32_SHDR *)sectionHeader + otherLocalCount)->sh_addr 
                  )
                  break;     
            }
          
            readString(sectionHeaderStringBuffer, 
                       ((ELF32_SHDR *)sectionHeader + 
                       ((ELF32_HDR *)elfHeader)->e_shstrindx
                       )->sh_size,
                       ((ELF32_SHDR *)sectionHeader + otherLocalCount)->sh_name
                       );

            printf("\" .\n");
            
            printf("The name of the required shared object is \""); 
                       
             
            if( readElfEntity( argumentValues[argumentFlags[FILE_NAME]],
                           ((ELF32_SHDR *)sectionHeader + otherLocalCount
                           )->sh_offset,
                           ((ELF32_SHDR *)sectionHeader + otherLocalCount
                           )->sh_size,
                           &dtStringTableOfDynamicSection) == ERROR )
               return ERROR;



             readString( dtStringTableOfDynamicSection,
                       ((ELF32_SHDR *)sectionHeader + otherLocalCount)->sh_size,
                        ((ELF32_DYN *)dynamicSection + count)->d_un.d_val);
           
             printf("\" .\n");    
                                                            
               
 
            allocateOrFreeMemory( &dtStringTableOfDynamicSection, ZERO );
  

/* ----------------------------------------------------------------------- */

         break;
         case DT_RPATH:
/* ------------------------------------------------------------------------ */
            localCount = ZERO;
            printf("\nELFX_DYN::d_tag = DT_RPATH\n");
          printf("The library search path string.....\n");
            printf("The library search path string is stored in section(DT_STRTAB) \"");

            while( ((ELF32_DYN *)dynamicSection + localCount)->d_tag 
                                                             != DT_NULL ){
               if( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                        == DT_STRTAB )
                  break;  
               
               localCount++;   
                
            }

            for(otherLocalCount = ZERO; 
                otherLocalCount < ((ELF32_HDR *)elfHeader)->e_shnum;
                otherLocalCount++){
                if( 
                    ((ELF32_DYN *)dynamicSection + localCount)->d_un.d_ptr
                    == ((ELF32_SHDR *)sectionHeader + otherLocalCount)->sh_addr 
                  )
                  break;     
            }
          
            readString(sectionHeaderStringBuffer, 
                       ((ELF32_SHDR *)sectionHeader + 
                       ((ELF32_HDR *)elfHeader)->e_shstrindx
                       )->sh_size,
                       ((ELF32_SHDR *)sectionHeader + otherLocalCount)->sh_name
                       );

            printf("\" .\n");
            
            printf("The search path string is \""); 
                       
             
            if( readElfEntity( argumentValues[argumentFlags[FILE_NAME]],
                           ((ELF32_SHDR *)sectionHeader + otherLocalCount
                           )->sh_offset,
                           ((ELF32_SHDR *)sectionHeader + otherLocalCount
                           )->sh_size,
                           &dtStringTableOfDynamicSection) == ERROR )
               return ERROR;



             readString( dtStringTableOfDynamicSection,
                       ((ELF32_SHDR *)sectionHeader + otherLocalCount)->sh_size,
                        ((ELF32_DYN *)dynamicSection + count)->d_un.d_val);
           
             printf("\" .\n");    
                                                            
               
 
            allocateOrFreeMemory( &dtStringTableOfDynamicSection, ZERO );
  

/* ----------------------------------------------------------------------- */
         break;
         case DT_SYMBOLIC:
         break;
         case DT_REL:
            localCount = 0;
            printf("\nELFX_DYN::d_tag = DT_REL\n");
            for(; localCount < ((ELF32_HDR *)elfHeader)->e_shnum;){
               if( ((ELF32_SHDR *)sectionHeader + localCount)->sh_addr 
                  == ((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr ){
                  printf("The address of section `");
                  readString(sectionHeaderStringBuffer, 
                             ((ELF32_SHDR *)sectionHeader + 
                             ((ELF32_HDR *)elfHeader)->e_shstrindx)->sh_size,
                             ((ELF32_SHDR *)sectionHeader 
                             + localCount)->sh_name ); 
                  printf("'.\n");
                  printf("The first byte of this section starts at address 0x%.8x\n",((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr);
               }
               localCount++; 
            }
            localCount = ZERO;
            printf("Size(DT_RELSZ) = ");
            while( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                         != DT_NULL      ){
               if( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                            == DT_RELSZ )
                  break;
               localCount++;
   
            }
            printf("%d(bytes) .\n", 
                   ((ELF32_DYN *)dynamicSection + localCount)->d_un.d_val );
            localCount = ZERO;
            printf("Size(DT_RELENT) = ");
            while( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                         != DT_NULL      ){
               if( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                            == DT_RELENT )
                  break;
               localCount++;
   
            }
            printf("%d(bytes) .\n", 
                   ((ELF32_DYN *)dynamicSection + localCount)->d_un.d_val );

         break;
         case DT_RELSZ:
         break;
         case DT_RELENT:
         break;

         case DT_DEBUG:
         break;
         case DT_TEXTREL:
         break;
         case DT_JMPREL:

/* -------------------------------------------------------------------- */
         printf("\nELFX_DYN::d_tag = DT_JMPREL\n");
         printf("Rlelocation section which effects the PLT section....\n");
         printf("Name = ");     

            for( localCount = ZERO; 
                 localCount < ((ELF32_HDR *)elfHeader)->e_shnum; 
                                                      localCount++){
               if( ((ELF32_SHDR *)sectionHeader + localCount)->sh_addr
                  == ((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr )
                  break;  
              
            }
            
            readString(sectionHeaderStringBuffer,
                  ((ELF32_SHDR *)sectionHeader +
                  ((ELF32_HDR *)elfHeader)->e_shstrindx)->sh_size, 
                  ((ELF32_SHDR *)sectionHeader + localCount)->sh_name ); 
              
              printf("(ELFX_DYN::d_un.d_ptr = 0x%.8x)\n", 
                      ((ELF32_DYN *)dynamicSection + count)->d_un.d_ptr);
           
            localCount = ZERO;    
            printf("Type = ");
            while( ((ELF32_DYN *)dynamicSection + localCount)->d_tag 
                                                         != DT_NULL    ){
                  if( ((ELF32_DYN *)dynamicSection + localCount)->d_tag 
                                                               == DT_PLTREL )
                      break;
                  localCount++;
            }
            
               
            switch( ((ELF32_DYN *)dynamicSection + localCount)->d_un.d_val ){

               case DT_REL:
                  printf("DT_REL");
               break;
               case DT_RELA:
                  printf("DT_RELA"); 
               break;
                                          
            }
            
            localCount = ZERO;
            printf("\nSize(DT_PLTRELSZ) = ");
            while( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                         != DT_NULL      ){
               if( ((ELF32_DYN *)dynamicSection + localCount)->d_tag
                                                            == DT_PLTRELSZ )
                  break;
               localCount++;
   
            }
            printf("%d(bytes) .\n", 
                   ((ELF32_DYN *)dynamicSection + localCount)->d_un.d_val );

                          
/* ------------------------------------------------------------------------ */  
            
         break; 
          
      }
 
      count++;
   }

   printf("\n");

   return(NO_ERROR); 
}





