/*
main.c
Written By, sonimalik@users.sf.net
This module and all other modules of this package are provided under GPL 
*/

#include <stdio.h>

#include "./alf.h"
#include "./stuff.h"
#include "./mainStuff.h"

/*
 With argument argc the storage specifier REGISTER_OR_STACK genrated an
 error so I removed it....
*/
GLOBAL 
__S32 main(__U16 argc, 
           REGISTER_OR_STACK void ** argv){

   STACK __U32 count   = ONE;
   STACK __U32 status  = ZERO;
     
   argumentValues = (__U8 **)argv;
 
   if( argc < TWO ){
      printf("Too few arguments.\n");
      useHelp(*argumentValues);
      return(ERROR);  
   }

   for(count=ZERO; count < ARGUMENT_COUNT; count++) 
      argumentFlags[count] = ZERO;
   count = ONE; 
    
   do{

      if(argumentValues[count][ZERO] == '-') 

/*
  The argument &argc is generating a warning; we are passing an address of 
  scalar which has no-linkage(either on stack or in register and is temporay, 
  exists till the function does not return. Since the function is the main(); 
  it never returns during the active life of the programm: Ignore the warning. 
*/
         if(argumentValues[count][ONE] == '-'){
            status = processStringArgument(
                     &argumentValues[count], &count, &argc);
            if(status == ERROR){
               useHelp(*argumentValues);
               return(ERROR);
            }
         } 
         else{            
            status = processCharacterArgument(argumentValues[count], &count);
            if(status == ERROR){
               useHelp(*argumentValues);
               return(ERROR);
            }
         }
               
      
      else{
         if(argumentFlags[FILE_NAME] == ZERO)
            argumentFlags[FILE_NAME] = count;
         else{
            printf("%s ?\n",argumentValues[count]);
            useHelp(*argumentValues);
            return(ERROR);  
         }
      }
      
       
      count++; 
   }while(count < argc);   
  
   switch(argumentFlags[HELP] + argumentFlags[VERSION]){

      case ZERO:
          if(init() == ERROR){
             useHelp(*argumentValues);
             return(ERROR);
          }
          else
             return(NO_ERROR);
      break;

      case ONE:         
         help();                     
      break;
      case TWO:         
         version();            
      break;  
      case THREE:
         version();
         help();
      break;  
   }                  
}


LOCAL 
__U16 processCharacterArgument(REGISTER_OR_STACK __U8 * argument, 
                               REGISTER_OR_STACK __U32 * ptrCount ){

   STACK __U32 count = NEGATIVE_ONE;

   switch( argument[ONE] ){
      case 'H':                               
         argumentFlags[HELP] = ONE;
      break;

      case 'V':                   
         argumentFlags[VERSION] = TWO;
      break;

      case 'h':
         if( argumentFlags[ELF_HEADER] == ZERO )
            argumentFlags[ELF_HEADER] = *ptrCount;
         else{
            printf("redundant %s.\n", argument);
            return(ERROR);
         }        
      break;

      case 'x':
         if(argumentFlags[SECTION_DUMP] == ZERO){
            argumentFlags[SECTION_DUMP] = *ptrCount;

            do{
               count++;
               argumentValues[*ptrCount][count] = 
               argumentValues[*ptrCount][count + TWO];
            }while(argumentValues[*ptrCount][count] != (__U8)NULL);
         
         }

         else{
            printf("redundant %s.\n", argument);
            return(ERROR);
         } 

      break;
      
      case 's':
         if(argumentFlags[SECTION_HEADERS] == ZERO)
            argumentFlags[SECTION_HEADERS] = *ptrCount;          
         else{
            printf("redundant %s.\n", argument);
            return(ERROR);           
         }
      break;

      case 'l':
         if( argumentFlags[PROGRAMM_HEADER] == ZERO )
            argumentFlags[PROGRAMM_HEADER] = *ptrCount;
         else{
            printf("redundant %s.\n", argument);
            return(ERROR);
         }
      break;

      case 'a':
         if( argumentFlags[ALL] == ZERO )
            argumentFlags[ALL] = *ptrCount;
         else{
            printf("redundant %s.\n", argument);
            return(ERROR);
         }              
      break;
      case 'r':
         if( argumentFlags[RELOCATIONS] == ZERO )
            argumentFlags[RELOCATIONS] = *ptrCount;
         else{
            printf("redundant %s.\n", argument);
            return(ERROR);
         }
      break;

      case 'd':
         if( argumentFlags[DYNAMIC] == ZERO )
            argumentFlags[DYNAMIC] = *ptrCount;
         else{
            printf("redundant %s.\n", argument);
            return(ERROR);
         }         
      break;

      case 'S':
         if(argumentFlags[SYMBOLS] == ZERO)
            argumentFlags[SYMBOLS] = *ptrCount;
         else{
            printf("redundant %s.\n", argument);
            return(ERROR);             
         }   
      break;

      default:
         printf("%s ?\n",argument);
         return(ERROR);
      break;
   }

   return(ZERO);      

}

LOCAL 
__U16 processStringArgument(REGISTER_OR_STACK __U8 ** argument, 
                            REGISTER_OR_STACK __U32 * ptrCount,
                            REGISTER_OR_STACK __U32 * ptrArgCount){

     if( strcmp( *argument, "--file-header" ) == ZERO )
        if( argumentFlags[ELF_HEADER] == ZERO ){           
           argumentFlags[ELF_HEADER] = *ptrCount;
           return(NO_ERROR);
        }
        else{
           printf("redundant %s.\n", *argument);
           return(ERROR); 
        } 

     if( strcmp( *argument, "--help" ) == ZERO ){
        argumentFlags[HELP] = ONE;
        return(NO_ERROR);
     }
     
     if( strcmp( *argument, "--version" ) == ZERO ){
        argumentFlags[VERSION] = TWO;     
        return(NO_ERROR);
     }
    
    if( strcmp( *argument, "--hex-dump") == ZERO ){


       if( argumentFlags[SECTION_DUMP] == ZERO ){
       
          if( *ptrCount < *ptrArgCount - ONE ){
             *ptrCount+=ONE;
             argumentFlags[SECTION_DUMP] = *ptrCount;
             return(NO_ERROR);
          }
          else{
             printf("Section name is missing.\n");
             return(ERROR);
          }

       }    

       else{
          printf("redundant %s.\n", *argument);
          return(ERROR);  
       }


    }
      
    if( strcmp( *argument, "--programm-headers") == ZERO 
        || strcmp( *argument, "--segments") == ZERO )
       if( argumentFlags[PROGRAMM_HEADER] == ZERO ){
          argumentFlags[PROGRAMM_HEADER] = *ptrCount;
          return(NO_ERROR);   
       }
       else{
          printf("redundant %s.\n", *argument);
          return(ERROR);
       }

    if( strcmp( *argument, "--section-headers") == ZERO )
       if( argumentFlags[SECTION_HEADERS] == ZERO ){
          argumentFlags[SECTION_HEADERS] = *ptrCount;
          return(NO_ERROR);
       }
       else{
          printf("redundant %s.\n", *argument);
          return(ERROR);
       }

    if( strcmp( *argument, "--relocs") == ZERO )
       if( argumentFlags[RELOCATIONS] == ZERO ){
          argumentFlags[RELOCATIONS] = *ptrCount;
          return(NO_ERROR);
       }
       else{
          printf("redundant %s.\n", *argument);
          return(ERROR);
       }

    if( strcmp( *argument, "--dynamic") == ZERO )
       if( argumentFlags[DYNAMIC] == ZERO ){
          argumentFlags[DYNAMIC] = *ptrCount;
          return(NO_ERROR);
       }
       else{
          printf("redundant %s.\n", *argument);
          return(ERROR);
       }    

    if( strcmp(*argument, "--syms") == ZERO || strcmp(*argument, "--symbols") == ZERO){
       if(argumentFlags[SYMBOLS] == ZERO){
          argumentFlags[SYMBOLS] = *ptrCount; 
          return(NO_ERROR);    
       }
       else{
          printf("redundant %s.\n", *argument);
          return(ERROR);
       }       
    }
     
    if( strcmp(*argument, "--ALL") == ZERO 
        || strcmp(*argument, "--all") == ZERO )
       if( argumentFlags[ALL] == ZERO ){
          argumentFlags[ALL] = *ptrCount;
          return(NO_ERROR);
       }
       else{
          printf("redundant %s.\n", *argument);
          return(ERROR);
       }
                
        
    printf("%s ?\n", *argument);                 
       return(ERROR);
    
  
}


LOCAL 
void useHelp(REGISTER_OR_STACK __U8 * argument){ 
   printf("To get help....\n");
   printf("%s -[H | -help]\n",argument);
}
LOCAL 
void version(void){
    printf("Alf, version 1.0.1 Written by, soni@iiterate.com\n");
    printf("For the new version of Alf visit....\n");
    printf("http://www.iiterate.com\n"); 
}
LOCAL
void help(void){
printf("Help for the Alf....\n");
printf("Any where a token appears with no preceeding single or double hyphens then the token is considered a file name.\n\n");
printf("-[a | -all | -ALL]            They are equal to -d, -h, -l, -s, S, -r.\n");
printf("-[d | -dynamic]               To display the .dynamic section, if present.\n");
printf("-[h | -file-header]           To display the ELF header.\n");
printf("-[H | -help]                  To display this message.\n");
printf("-[l | -programm-headers | -segments]\n");
printf("                              To display the programm headers, if present.\n");
printf("-[r | -relocs]                To display the relocation sections.\n");
printf("-[s | -section-headers]       To display the section headers.\n");
printf("-[S | --syms | --symbols]     To display the symbol table.\n");
printf("-[V | -version]               To get the version information of the Alf.\n");
printf("-[x<.name> | -hex-dump <.name>]\n");      
printf("                              To dump the contents of the section.\n\n");
printf("Report any bugs to sonimalik@users.sf.net\n");
}
