/*
programmHeader.c
Written by, sonimalik@users.sf.net 
This module and all other modules of this package are provided under GPL 
*/

#include <stdio.h>

#include "./alf.h"
#include "./stuff.h"
#include "./programmHeaderStuff.h"

GLOBAL
void displayProgrammHeader(void){

   STACK __U32 count      = ZERO;
   STACK __U32 localCount = ZERO;

  if( ((ELF32_HDR *)elfHeader)->e_phnum == ZERO ){
      printf("%s\n", "NO_PROGRAMM_HEADERS");
      return;
   }
 
   printf("\n** *Programm Headers* **\n");
   printf("------------------------\n"); 
      printf("Type     Offset    Virtual   Physical  File      Memory    Align     Flags\n"); 
   for(count = ZERO; count < ((ELF32_HDR *)elfHeader)->e_phnum; count++){

      switch( ((ELF32_PHDR *)programmHeader + count)->p_type ){
         case PT_NULL:
            printf("NULL   ");
         break;
         case PT_LOAD:
            printf("LOAD   ");
         break;
         case PT_DYNAMIC:
            printf("DYNAMIC");
         break; 
         case PT_INTERP:
            printf("INTERP ");
         break;
         case PT_NOTE:
            printf("NOTE   ");
         break;
         case PT_SHLIB:
            printf("SHLIB  ");
         break;
         case PT_PHDR:
            printf("PHDR   ");
         break;         
         default:
            printf("-------");
         break;
      }
      
      printf("  %.8x", ((ELF32_PHDR *)programmHeader + count)->p_offset );  
      printf("  %.8x", ((ELF32_PHDR *)programmHeader + count)->p_vaddr );
      printf("  %.8x", ((ELF32_PHDR *)programmHeader + count)->p_paddr );
      printf("  %.8x", ((ELF32_PHDR *)programmHeader + count)->p_filesz );
      printf("  %.8x", ((ELF32_PHDR *)programmHeader + count)->p_memsz );
   
      printf("  %.8x", ((ELF32_PHDR *)programmHeader + count)->p_align );
      
      printf("  "); 
      if( ((ELF32_PHDR *)programmHeader + count)->p_flags & PF_X ) 
         printf("X");
      if( ((ELF32_PHDR *)programmHeader + count)->p_flags & PF_W ) 
         printf("W");
      if( ((ELF32_PHDR *)programmHeader + count)->p_flags & PF_R ) 
         printf("R");
      if( ((ELF32_PHDR *)programmHeader + count)->p_flags & PF_MASKOS )
         printf("(OS)");
      if( ((ELF32_PHDR *)programmHeader + count)->p_flags & PF_MASKPROC ) 
         printf("(PS)");
       
 
      printf("\n");    
   }

   printf("\nSection to Segment mapping:\n");
   for(count = ZERO; count < ((ELF32_HDR *)elfHeader)->e_phnum; count++){

      printf("[segment %.2d] ", count);   

      for(localCount = ZERO; localCount < ((ELF32_HDR *)elfHeader)->e_shnum; 
      localCount++){
           if( ((ELF32_SHDR *)sectionHeader + localCount)->sh_addr > ZERO ) 
           if( 
                ( 
                     ((ELF32_SHDR *)sectionHeader + localCount)->sh_addr 
                     >= ((ELF32_PHDR *)programmHeader + count)->p_vaddr 
                )   
 
                &&
  
                (  
                   (
                      ((ELF32_SHDR *)sectionHeader + localCount)->sh_addr +
                      ((ELF32_SHDR *)sectionHeader + localCount)->sh_size  
                   )

                   <=   

                   (   
                      ((ELF32_PHDR *)programmHeader + count)->p_vaddr +
                      ((ELF32_PHDR *)programmHeader + count)->p_memsz 
                   )
                 
                )
                            
             ){
              if( 
                 ( 
                   ((ELF32_SHDR *)sectionHeader + localCount)->sh_addr +
                   ((ELF32_SHDR *)sectionHeader + localCount)->sh_size 
                 )
                 !=
                 ((ELF32_SHDR *)sectionHeader + localCount)->sh_addr 
                )
                  readString( sectionHeaderStringBuffer, 
                             ((ELF32_SHDR *)sectionHeader +
                             ((ELF32_HDR *)elfHeader)->e_shstrindx)->sh_size,
                             ((ELF32_SHDR *)sectionHeader + localCount)->sh_name
                  );

           }      

      }
         
       printf("\n");  
   }
   printf("\n");
   
   printf("Notes:\n"); 
   printf("Note 1: Offset = ELFX_SHDR[1st]::sh_offset.\n");
   printf("Note 2: Virtual = ELFX_SHDR[1st]::sh_addr.\n");
   printf("Note 3: Physical = AT(ADDR(.sectionName of 1st) - constant).\n"); 
   printf("Note 4: File = ELFX_SHDR[1st...Last]::sh_size - ELFX_SHDR[.bss]::sh_size.\n");
   printf("Note 5: Memory = ELFX_SHZR[1st...Last]::sh_size.\n\n");
}
