/* stuff.h */
/* Written By, Soni. */

#include <string.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/io.h>
#include <stdlib.h>
/* #include <alloc.h> */


#define NEGATIVE_ONE                   0xFFFFFFFF
#define ZERO                           0x00000000
#define ONE                            0x00000001
#define TWO                            0x00000002
#define THREE                          0x00000003
#define FOUR                           0x00000004
#define FIVE                           0x00000005
#define SIX                            0x00000006
#define SEVEN                          0x00000007
#define EIGHT                          0x00000008
#define NINE                           0x00000009
#define TEN                            0x0000000A
#define ELEVEN                         0x0000000B
#define TWELVE                         0x0000000C
#define SIXTEEN                        0x00000010
#define SEVENTEEN                      0x00000011


#define ERROR                          0xFFFF
#define NO_ERROR                       0x0000
#define LITTLE_MACHINE                 0x0000
/*#define LITTLE_ENDIAN                  0x0000*/
#define BIG_MACHINE                    0x0001
/*#define BIG_ENDIAN                     0x0002*/

#define LOCAL 			       static
#define GLOBAL			       extern  	
#define STACK			       auto
#define REGISTER_OR_STACK	       register	

#define NOT_FOUND		       "SECTION_NOT_FOUND"
#define NO_RELOCATION		       "NO_RELOCATION_SECTION"

/* 
increase or decrease the ARGUMENT_COUNT for each addition or substraction
from the following macro set.
*/
#define ARGUMENT_COUNT		0x000B
/* the macro set.... */
#define FILE_NAME		0x0000
#define ELF_HEADER		0x0001
#define SECTION_HEADERS		0x0002
#define VERSION			0x0003
#define HELP			0x0004
#define PROGRAMM_HEADER		0x0005
#define ALL                     0x0006
#define SECTION_DUMP            0x0007
#define RELOCATIONS		0x0008
#define DYNAMIC			0x0009
#define SYMBOLS			0x000A
/* the macro set ends here. */

/* defined in init.c */
/* &fileHandle, char * fileName */
GLOBAL __U16 openOrCloseFile(REGISTER_OR_STACK void *, 
                             REGISTER_OR_STACK void *); 
/* &fileHandle, void * buffer, unsigned int bufferLength */
GLOBAL __U16 readFile(REGISTER_OR_STACK void *, 
                      REGISTER_OR_STACK void **, 
                      REGISTER_OR_STACK __U32); 
/* unsigned char,           pointer,    size */
GLOBAL __U16 allocateOrFreeMemory(REGISTER_OR_STACK void **,
                                  REGISTER_OR_STACK __U32);

/* file name, entity offset, entity size, address of buffer */
GLOBAL __U16 readElfEntity(void *, __U32, __U32, void **);

/* buffer, buffer size, index into buffer */

GLOBAL __U16 readString(__U8 *, __U32, __U32); 

/* defined in initStuff.h */
GLOBAL void * elfHeader;
GLOBAL void * sectionHeader;
GLOBAL void * programmHeader;
GLOBAL void * sectionHeaderStringBuffer;
GLOBAL void * sectionDump;
GLOBAL void * dynamicSection;
GLOBAL void * dtStringTableOfDynamicSection;


/* defined in the mainStuff.h */
GLOBAL __U16 argumentFlags[];
GLOBAL __U8 ** argumentValues;

/*
	:)
*/
